/*
 File: epsilon_rules.h
 Date and Time: Fri Jan 30 18:55:10 2015 
*/
#ifndef __epsilon_rules_h__
#define __epsilon_rules_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "yacco2_stbl.h"
using namespace NS_yacco2_terminals;
#define EPSILON_YES 0
#define EPSILON_NO 1
#define EPSILON_DONT_KNOW 2
#define EPSILON_MAYBE 3

struct elem_list_type{
  rule_def* rule_;
  T_subrule_def* subrule_;
  AST* elem_t_;
  int gen_epsilon_;
  int gen_t_;
  elem_list_type
	(rule_def* Rule
    ,T_subrule_def* Subrule
    ,AST* Elem_t){
    rule_ = Rule;
    subrule_ = Subrule;
    elem_t_ = Elem_t;
    gen_epsilon_ = EPSILON_DONT_KNOW;
    gen_t_ = false;
  };
  elem_list_type(){
    rule_ = 0;
    subrule_ = 0;
    elem_t_ = 0;
    gen_epsilon_ = false;
    gen_t_ = false;
  };
};
  
// monolithic grammar: no thread
extern yacco2::State S1_Cepsilon_rules;
namespace NS_epsilon_rules {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[7];
};
class Cepsilon_rules: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Repsilon_rules_ = 569//start_of_rule_list + 0
    ,rhs1_Repsilon_rules_ = 1
   ,R_Rrules_ = 570//start_of_rule_list + 2
    ,rhs1_Rrules_ = 2
    ,rhs2_Rrules_ = 3
   ,R_Rrule_ = 571//start_of_rule_list + 4
    ,rhs1_Rrule_ = 4
   ,R_Rrule_def_ = 572//start_of_rule_list + 6
    ,rhs1_Rrule_def_ = 5
   ,R_Rsubrules_ = 573//start_of_rule_list + 8
    ,rhs1_Rsubrules_ = 6
    ,rhs2_Rsubrules_ = 7
   ,R_Rsubrule_ = 574//start_of_rule_list + 10
    ,rhs1_Rsubrule_ = 8
   ,R_Rsubrule_def_ = 575//start_of_rule_list + 12
    ,rhs1_Rsubrule_def_ = 9
  };
  //no of la sets = 4
  //no of states = 12
  Cepsilon_rules();
  ~Cepsilon_rules();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[10];
  
    public:
		std::list<elem_list_type > derives_list_;
		rule_def* rule_def_;
		T_subrule_def* subrule_def_;
		AST* elem_t_;
		tok_can< AST* > * ip_can_;
       void deal_with_derives_list();
	   void deal_with_undecided_derives_list();
	   AST* advance_element(AST* Elemt);
  
 };
struct Repsilon_rules;
struct Rrules;
struct Rrule;
struct Rrule_def;
struct Rsubrules;
struct Rsubrule;
struct Rsubrule_def;
struct Repsilon_rules:public yacco2::CAbs_lr1_sym {
  Repsilon_rules(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rrules:public yacco2::CAbs_lr1_sym {
  Rrules(yacco2::Parser* P);
  public:
};

struct Rrule:public yacco2::CAbs_lr1_sym {
  Rrule(yacco2::Parser* P);
  public:
};

struct Rrule_def:public yacco2::CAbs_lr1_sym {
  Rrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rsubrules:public yacco2::CAbs_lr1_sym {
  Rsubrules(yacco2::Parser* P);
  public:
};

struct Rsubrule:public yacco2::CAbs_lr1_sym {
  Rsubrule(yacco2::Parser* P);
  public:
};

struct Rsubrule_def:public yacco2::CAbs_lr1_sym {
  Rsubrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

} // end of namespace

#endif
